#pragma once

#include "parser.hh"

#include "../asp-domain/asp-domain.hpp"


namespace parser {

class Driver
{
  friend class parser::Parser; // to set program and call error function
public:
	Driver(std::istream *stream);
	~Driver();
	domain::Program* parse(); // parse from the constructor-given input stream and return the parsed ASP program. Caller is responsible for deleting the program object.

private:
	void error(const parser::location& l, const std::string& m);
	domain::Program* program; // set by the parser
	std::istream *stream;
};

} // namespace parser
